#!/usr/bin/env python

# Inspire by Conbagui's  tutorial found here: https://www.deviantart.com/conbagui/art/Metal-logo-371890414

# author: Pocholo
# date: 9/14/20

# Comments directed to http://gimpchat.com

# Installation:
# This script should be placed in the user plugins folder

# Copyright (C)

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by   
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.

#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <https://www.gnu.org/licenses/>.

from gimpfu import *

def pm_metal_car_logo(backColor, customtext, fontname, size, justify, linespa):
		
	#Variables
	width = 1200
	height = 700
		
	#Create the background
	img = pdb.gimp_image_new(width, height, RGB)
	backLayer = pdb.gimp_layer_new(img, width, height, RGB_IMAGE, "Background", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, backLayer, 0)
	pdb.gimp_drawable_fill(backLayer, FILL_TRANSPARENT)
	pdb.gimp_context_set_foreground(backColor)
	pdb.gimp_context_set_background(backColor)
	pdb.gimp_edit_blend(backLayer, 
								0,  #blend-mode
	            LAYER_MODE_NORMAL,  #paint-mode
	                            2,  #gradient type
	                          100,  #opacity
							    0,  #offset
								0,  #repeat
							FALSE,  #reverse
							FALSE,  #supersample
								3,  #max-depth
							 0.20,  #threshold
						     TRUE,  #dither
							  600,  #width1
							  350,  #height1
							  900,  #width2
							  350)  #height2
	
	pdb.plug_in_gauss(img, backLayer, 400, 400, 1)
	pdb.plug_in_hsv_noise(img, backLayer, 8, 0, 0, 50)
	pdb.script_fu_fuzzy_border(img, backLayer, (0, 0, 0), 
	                                                  60, 
												    TRUE, 
												    4.00, 
												   FALSE, 
												     100, 
												   FALSE, 
												   FALSE)
	borderLayer = pdb.gimp_image_get_layer_by_name(img, "layer 1")
	pdb.gimp_drawable_set_name(borderLayer, "Border")
	pdb.plug_in_gauss(img, borderLayer, 200, 200, 1)
	
	#Show process
	pdb.gimp_display_new(img)
	
	#Create the emblem
	emblemLayer = pdb.gimp_layer_new(img, width, height, RGB_IMAGE, "Emblem", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, emblemLayer, 0)
	pdb.gimp_layer_add_alpha(emblemLayer)
	pdb.gimp_drawable_fill(emblemLayer, FILL_TRANSPARENT)
	pdb.gimp_image_select_ellipse(img, 2, 250, 175, 700, 350)
	pdb.plug_in_sel2path(img, emblemLayer)
	pdb.gimp_context_set_defaults()
	pdb.gimp_edit_bucket_fill(emblemLayer, BUCKET_FILL_BG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
	pdb.gimp_selection_none(img)
	
	#Gradient overlay
	pdb.python_layerfx_gradient_overlay(img, emblemLayer, 
										   ("Metallic_4"),   #gradient 
														 0,   #gradient_type linear 
														 0,   #repeat none 
													  TRUE,   #reverse 
													   100,   #opacity 
														 0,   #mode - normal 
													   600,   #center_x 
													   350,   #center_y 
														90,   #angle 
													   300,   #width 
													 FALSE)   #merge
	
		
	gradLayer = pdb.gimp_image_get_layer_by_name(img, "Emblem-gradient")
	pdb.gimp_context_set_foreground((0, 0, 0))
	pdb.gimp_context_set_antialias(TRUE)
	pdb.gimp_context_set_line_cap_style(CAP_ROUND)
	pdb.gimp_context_set_line_join_style(JOIN_MITER)
	pdb.gimp_context_set_line_miter_limit(10)
	pdb.gimp_context_set_line_width(2)
	pdb.gimp_context_set_stroke_method(STROKE_LINE)
	vector1 = pdb.gimp_image_get_active_vectors(img)
	pdb.gimp_edit_stroke_vectors(gradLayer, vector1)
	
	#Bevel and Emboss for the text copy
	pdb.gimp_image_set_active_layer(img, gradLayer)
	pdb.python_layerfx_bevel_emboss(img, gradLayer, 
												 1,   #style inner bevel
											     5,   #depth 
												 0,   #direction 
												20,   #size 
												2,   #soften
											   130,   #angle 
												30,   #altitude 
												 0,   #gloss_contour - line 
								         ("White"),   #highlight_color 
												 4,   #highlight_mode screen
												75,   #highlight_opacity
										 ("Black"),   #shadow_color 
												 3,   #shadow_mode multiply
											    75,   #shadow_opacity 
												 0,   #surface_contour - line 
											 FALSE,   #use_texture 
										"3D Green",   #pattern 
											   100,   #scale 
											   100,   #tex_depth 
											  TRUE,   #invert 
											 FALSE)   #merge
	
	#Make plate more chrome look
	pdb.gimp_curves_spline(emblemLayer, 0, 18, (0, 0, 33, 8, 68, 38, 97, 102, 129, 166, 158, 209, 191, 235, 222, 247, 255, 255))
	
	#Create the emblem center for the text
	darkLayer = pdb.gimp_layer_new(img, width, height, RGB_IMAGE, "Dark", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, darkLayer, 0)
	pdb.gimp_layer_add_alpha(darkLayer)
	pdb.gimp_drawable_fill(darkLayer, FILL_TRANSPARENT)
	pdb.gimp_context_set_defaults()
	pdb.gimp_image_select_ellipse(img, 2, 270, 195, 660, 315)	
	pdb.gimp_edit_bucket_fill(darkLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
	pdb.plug_in_gmic_qt(img, darkLayer, 1, 0, "-v - -fx_halftone 12,0,0,0,9,12,12,2,1.6")
	pdb.gimp_levels(darkLayer, HISTOGRAM_VALUE, 0, 100, 1.00, 0, 255)
	pdb.gimp_selection_none(img)
	
	#Drop Shadow
	pdb.python_layerfx_drop_shadow(img, darkLayer,
									    ("Black"),   #color
											  100,   #opacity
												0,   #contou - linear
												0,   #noise
											    3,   #mode - multiply
											   80,   #spread
											   10,   #size
											  120,   #offset_angle
											    0,   #offset_distance
											  TRUE,   #knockout
											 FALSE)   #merge
	
	
	#Create the text		
	textW = size/0.2
	textH = size/0.7
	pdb.gimp_context_set_foreground((255, 255, 255))
	textLayer = pdb.gimp_text_fontname(img, None, 0, 0, customtext, 10, 1, size, PIXELS, fontname)
	pdb.gimp_text_layer_set_justification(textLayer, justify)
	pdb.gimp_text_layer_set_line_spacing(textLayer, linespa)
	
	#Resize text
	pdb.gimp_layer_scale (textLayer, textW, textH, TRUE)
	
		
	#Making the text centered	
	textLayer = pdb.gimp_image_get_active_layer(img)
	pdb.gimp_image_set_active_layer(img, textLayer)
	wh = pdb.gimp_drawable_width(textLayer)
	hh = pdb.gimp_drawable_height(textLayer)
	w = pdb.gimp_image_width(img)
	h = pdb.gimp_image_height(img)
	pdb.gimp_image_set_active_layer(img,textLayer)
	centerx=w/2
	centery=h/2
	adw=wh/2
	adh=hh/2
	sw=centerx - adw
	sh=centery - adh		
	pdb.gimp_layer_set_offsets(textLayer, sw, sh)
	pdb.gimp_layer_resize_to_image_size(textLayer)
	
	pdb.gimp_item_set_name(textLayer, "Text")
	
	#Gradient overlay
	pdb.python_layerfx_gradient_overlay(img, textLayer, 
										("Metallic_8"),   #gradient 
												     0,   #gradient_type linear 
													 0,   #repeat none 
												  TRUE,   #reverse 
												   100,   #opacity 
													 0,   #mode - normal 
												   600,   #center_x 
												   350,   #center_y 
											        90,   #angle 
													50,   #width 
												 TRUE)   #merge
	
	textLayer = pdb.gimp_image_get_layer_by_name(img, "Text")
	
	#Outer glow
	pdb.python_layerfx_outer_glow(img, textLayer, 
								 (219, 219, 219),   #color
											  20,   #opacity
											   0,   #contou
											   0,   #noise
											   4,   #mode - screen
											   0,   #spread 
											  20,   #size 
											TRUE,   #knockout 
										   FALSE)   #merge
	
	#Bevel and emboss
	pdb.python_layerfx_bevel_emboss(img, textLayer, 
												  1,   #style inner bevel
												 65,   #depth 
												  0,   #direction 
											     14,   #size 
											      7,   #soften
												130,   #angle 
												 20,   #altitude 
												  0,   #gloss_contour- linear 
								    (255, 255, 255),   #highlight_color 
												  4,   #highlight_mode - screen
												 75,   #highlight_opacity
										  (0, 0, 0),   #shadow_color 
												  3,   #shadow_mode - multiply
											 	 75,   #shadow_opacity 
												  6,   #surface_contour - half round 
											  FALSE,   #use_texture 
									    "Dried mud",   #pattern 
											     50,   #scale 
											    100,   #tex_depth 
											   TRUE,   #invert 
											   TRUE)   #merge
		
	textLayer = pdb.gimp_image_get_layer_by_name(img, "Text")
	
	#make text shiny chrome look
	pdb.gimp_curves_spline(textLayer, 0, 12, (0, 0, 31, 0, 96, 161, 160, 0, 192, 255, 255, 255))
	
register(
	"pm_metal_car_logo",
	"Creates a Metal automobile logo",
	"Creates a Metal automobile logo",
	"Pocholo",
	"Pocholo",
	"2020",
	"Metal car logo",
	"",
[	
	
	(PF_COLOR, "backcolor", "Background color", (200, 22, 0)),
	(PF_STRING, "customtext", "Text string", 'Gimp'),
	(PF_FONT, "fontname", "Font name", "Remarcle"),
	(PF_SPINNER, "size", "Text size", 120, (120, 120, 1)),
	(PF_OPTION, "justify", "Justify", 2, ("Left", "Right", "Centered", "Fill")),
	(PF_ADJUSTMENT, "linespa", "Line spacing", 0, (0, 20, 1)),	
],
[],
pm_metal_car_logo, menu="<Image>/Pocholo-scripts/Metal car logo")
main()		